common/models/Survey.php
<?php


namespace common\models;

use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use Yii;

class Survey extends ActiveRecord
{
    //GM - директор ГиперМаркета
    //BF - директор группы Больших Форматов
    //RMKS - Региональный Менеджер по Клиентским Сервисам

    const STATUS_INIT = 0; //any new survey
    const STATUS_NEW = 10; //from this till the closed - has alert

    const STATUS_GM_EXPIRED = 20;
    const STATUS_GM_TAKEN = 30;
    const STATUS_GM_CLOSED = 40;

    const STATUS_BF_REVISION = 50;
    const STATUS_BF_CLOSED = 60;

    const STATUS_CLASSES = [
        self::STATUS_INIT => 'SurveyStatusInit',
        self::STATUS_NEW => 'SurveyStatusNew',
        self::STATUS_GM_EXPIRED => 'SurveyStatusGMExpired',
        self::STATUS_GM_TAKEN => 'SurveyStatusGMTaken',
        self::STATUS_GM_CLOSED => 'SurveyStatusGMClosed',
        self::STATUS_BF_REVISION => 'SurveyStatusBFRevision',
        self::STATUS_BF_CLOSED => 'SurveyStatusBFClosed',
    ];

    const BAD_NPS = [0, 1, 2, 3];
    const PASSIVE_NPS = [4];
    const GOOD_NPS = [5];

    public static $surveys = [
        SurveyType::CASH => [
            1 => 'Оцените доброжелательность кассира',
            2 => 'Оцените скорость облуживания на кассе',
        ],
        SurveyType::FRUIT => [
            1 => 'Оцените свежесть товаров в Отделе Фрукты и овощи',
            2 => 'Оцените чистоту в Отделе Фрукты и овощи',
        ],
        SurveyType::PROD => [
            1 => 'Оцените качество товаров в отделе Собственного производства',
            2 => 'Оцените ассортимент товаров в отделе Собственного производства',
            3 => 'Оцените доброжелательность продавца в отделе Собственного производства',
        ],
        SurveyType::SERVICE => [
            1 => 'Решили ли сотрудники Ваш вопрос?',
            2 => 'Стремились ли сотрудники помочь Вам?',
        ],
        SurveyType::SHOPPING => [
            1 => 'Оцените дружелюбность и отзывчивость персонала',
            2 => 'Оцените ассортимент в магазине',
            3 => 'Насколько Вы готовы рекомендовать данный магазин?',
        ],
    ];

    public static $statusValues = [
//    const STATUS_INIT = 0; //any new survey
//    const STATUS_NEW = 10; //from this till the closed - has alert
//
//    const STATUS_GM_TAKEN = 20;
//    const STATUS_GM_EXPIRED = 30;
//    const STATUS_GM_CLOSED = 40;
//
//    const STATUS_BF_REVISION = 50;
//    const STATUS_BF_CLOSED = 60;
        Survey::STATUS_INIT => 'Init',
        Survey::STATUS_NEW => 'Новый',
        Survey::STATUS_GM_TAKEN => 'Взят в работу',
        Survey::STATUS_GM_EXPIRED => 'Просрочен',
        Survey::STATUS_GM_CLOSED => 'На подтверждении',
        Survey::STATUS_BF_REVISION => 'Взят в работу',
        Survey::STATUS_BF_CLOSED => 'Закрыт',
    ];

    protected $oldStatus;
    public $imageFiles = [];

    public static function tableName()
    {
        return '{{survey}}';
    }

    public function behaviors()
    {
        return [
            [
                'class' => TimestampBehavior::className(),
                'attributes' => [
                    ActiveRecord::EVENT_BEFORE_INSERT => ['created_at', 'updated_at'],
                    ActiveRecord::EVENT_BEFORE_UPDATE => ['updated_at'],
                ],
//                // если вместо метки времени UNIX используется datetime:
//                'value' => new Expression('NOW()'),
            ],
        ];
    }

    public function rules()
    {
        return [
//            [['client_id', 'doc_id'], 'required'],
            [['survey_id', 'client_id', 'store_id', 'dep_id', 'nps', 'question1', 'question2', 'question3', 'question4'], 'integer'],
            [['survey_id', 'client_id', 'store_id', 'dep_id', 'nps', 'question1', 'question2', 'question3', 'question4',
                'comment', 'status', 'status_updated_at', 'created_at', 'updated_at'], 'safe'],
            [['imageFiles'], 'file', 'skipOnEmpty' => true, 'extensions' => 'png, jpg, jpeg', 'maxFiles' => 4],
        ];
    }

    public function afterFind()
    {
        $this->oldStatus = $this->status;
        return parent::afterFind();
    }

    public function beforeSave($options = [])
    {
        if ($this->status != $this->oldStatus)
            $this->status_updated_at = time();

        return parent::beforeSave($this->isNewRecord);
    }

    public function upload()
    {
        if ($this->validate()) {
            foreach ($this->imageFiles as $file) {
                $path = Yii::getAlias('@frontend') . '/web/uploads/' . $this->survey_id . '_' . $file->baseName . '.' . $file->extension;
                $file->saveAs($path);
                @chmod($path, 0755);
            }
            return true;
        } else {
            return false;
        }
    }

    public function getStore()
    {
        return $this->hasOne(Store::className(), ['id' => 'store_id']);
    }

    public function getDepartment()
    {
        return $this->hasOne(Department::className(), ['id' => 'dep_id']);
    }

    public function getDeliveryDoc()
    {
        return $this->hasOne(DeliveryDoc::className(), ['doc_id' => 'doc_id']);
    }

    public function getClient()
    {
        return $this->hasOne(Client::className(), ['client_id' => 'client_id']);
    }

    public function getLogs()
    {
        return $this->hasMany(Log::className(), ['survey_id' => 'survey_id']);
    }

}

common/models/User.php
<?php

namespace common\models;

use Yii;
use yii\base\NotSupportedException;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;
use yii\web\IdentityInterface;

/**
 * User model
 *
 * @property integer $id
 * @property string $username
 * @property string $password_hash
 * @property string $password_reset_token
 * @property string $verification_token
 * @property string $email
 * @property string $auth_key
 * @property integer $status
 * @property integer $created_at
 * @property integer $updated_at
 * @property string $password write-only password
 */
class User extends ActiveRecord implements IdentityInterface
{
    const STATUS_DELETED = 0;
    const STATUS_INACTIVE = 9;
    const STATUS_ACTIVE = 10;

    const ROLE_GM = 1;
    const ROLE_BF = 2;
    const ROLE_RMKS = 3;
    const ROLE_OPER_BF = 4;
    const ROLE_SPEC_OFFICE = 5;
    const ROLE_SPEC_MANAG = 6;
    const ROLE_SPEC_HEAD = 7;

    public static $access = [
        self::ROLE_GM => 'Директор гипермаркета',
        self::ROLE_BF => 'Директор группы больших форматов (БФ)',
        self::ROLE_RMKS => 'Региональный менеджер по клиентским сервисам (РМКС)',
        self::ROLE_OPER_BF => 'Операционный директор округа БФ',
        self::ROLE_SPEC_OFFICE => 'Специалист Офис',
        self::ROLE_SPEC_MANAG => 'Менеджер Офис',
        self::ROLE_SPEC_HEAD => 'Руководитель направления Офис',
    ];

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return '{{%user}}';
    }

    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            TimestampBehavior::className(),
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['username', 'email'], 'required'],
            [['surname_name', 'access', 'phone', 'area_id', 'store_id', 'created_at', 'updated_at'], 'safe'],
            [['status', 'area_id', 'store_id'], 'integer'],
            [['username', 'password_hash', 'verification_token', 'password_reset_token', 'email'], 'string', 'max' => 255],
            [['auth_key'], 'string', 'max' => 32],
            [['username'], 'unique'],
            [['email'], 'unique'],
            ['status', 'default', 'value' => self::STATUS_ACTIVE],
            ['status', 'in', 'range' => [self::STATUS_ACTIVE, self::STATUS_INACTIVE, self::STATUS_DELETED]],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentity($id)
    {
        return static::findOne(['id' => $id, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * {@inheritdoc}
     */
    public static function findIdentityByAccessToken($token, $type = null)
    {
        throw new NotSupportedException('"findIdentityByAccessToken" is not implemented . ');
    }

    /**
     * Finds user by username
     *
     * @param string $username
     * @return static|null
     */
    public static function findByUsername($username)
    {
        return static::findOne(['username' => $username, 'status' => self::STATUS_ACTIVE]);
    }

    /**
     * Finds user by password reset token
     *
     * @param string $token password reset token
     * @return static|null
     */
    public static function findByPasswordResetToken($token)
    {
        if (!static::isPasswordResetTokenValid($token)) {
            return null;
        }

        return static::findOne([
            'password_reset_token' => $token,
            'status' => self::STATUS_ACTIVE,
        ]);
    }

    /**
     * Finds user by verification email token
     *
     * @param string $token verify email token
     * @return static|null
     */
    public static function findByVerificationToken($token)
    {
        return static::findOne([
            'verification_token' => $token,
            'status' => self::STATUS_INACTIVE
        ]);
    }

    /**
     * Finds out if password reset token is valid
     *
     * @param string $token password reset token
     * @return bool
     */
    public static function isPasswordResetTokenValid($token)
    {
        if (empty($token)) {
            return false;
        }

        $timestamp = (int)substr($token, strrpos($token, '_') + 1);
        $expire = Yii::$app->params['user . passwordResetTokenExpire'];
        return $timestamp + $expire >= time();
    }

    /**
     * {@inheritdoc}
     */
    public function getId()
    {
        return $this->getPrimaryKey();
    }

    /**
     * {@inheritdoc}
     */
    public function getAuthKey()
    {
        return $this->auth_key;
    }

    /**
     * {@inheritdoc}
     */
    public function validateAuthKey($authKey)
    {
        return $this->getAuthKey() === $authKey;
    }

    /**
     * Validates password
     *
     * @param string $password password to validate
     * @return bool if password provided is valid for current user
     */
    public function validatePassword($password)
    {
        return Yii::$app->security->validatePassword($password, $this->password_hash);
    }

    /**
     * Generates password hash from password and sets it to the model
     *
     * @param string $password
     */
    public function setPassword($password)
    {
        $this->password_hash = Yii::$app->security->generatePasswordHash($password);
    }

    /**
     * Generates "remember me" authentication key
     */
    public function generateAuthKey()
    {
        $this->auth_key = Yii::$app->security->generateRandomString();
    }

    /**
     * Generates new password reset token
     */
    public function generatePasswordResetToken()
    {
        $this->password_reset_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Generates new token for email verification
     */
    public function generateEmailVerificationToken()
    {
        $this->verification_token = Yii::$app->security->generateRandomString() . '_' . time();
    }

    /**
     * Removes password reset token
     */
    public function removePasswordResetToken()
    {
        $this->password_reset_token = null;
    }

    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'user_id' => 'ID',
            'username' => 'Логин',
            'email' => 'Электронный адрес',
            'status' => 'Статус',
        ];
    }

    public function can($level)
    {
        $user = Yii::$app->user->getIdentity();
        return in_array($user->id, Yii::$app->authManager->getUserIdsByRole('admin'));
//            || in_array($user->access, User::$levels[$level]);
    }

    public function getArea()
    {
        return $this->hasOne(Area::className(), ['id' => 'area_id']);
    }

    public function getStore()
    {
        return $this->hasOne(Store::className(), ['id' => 'store_id']);
    }
}

backend/views/widgets/views/_site-filter.php
<?php

use yii\helpers\Html;
use yii\bootstrap4\ActiveForm;

?>

<div class="pink-block">
    <div class="top-nav">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
        <div class="navbar-user">
            <div class="user">
                <div class="user-wrapper show-user-dropdown">
                    <div class="user-name"><?= Yii::$app->user->getIdentity()->surname_name ?></div>
                    <div class="icon-user"></div>
                </div>
                <div class="dropdown-user">
                    <ul>
                        <li>
                            <?= Html::a('Выход', ['site/logout'], [
                                'class' => 'logout',
                                'title' => 'Выход',
                                'data' => ['method' => 'post']]) ?>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-header"><?= $title ?></div>
    <?php $form = ActiveForm::begin([
        'id' => 'delivery-filter-form',
        'method' => 'post',
    ]); ?>
    <div class="filter-wrapper">
        <!-- блок выбора даты -->
        <div class="box box-date">
            <h6 class="f-name-height">Дата опроса</h6>
            <div class="form-group">
                <input type="text" class="form-control" name="Form[createdAt]"
                       value="<?= $filters['createdAt'] ?>">
                <div class="help-block"></div>
            </div>
        </div>

        <!-- блок выбора расположения -->
        <div class="box">
            <h6>Магазин</h6>
            <div class="form-group">
                <select class="form-control" name="Form[storeId]">
                    <option value="">Все</option>
                    <?php foreach ($stores as $item): ?>
                        <option value="<?= $item->id ?>"<?= $filters['storeId'] == $item->id ? ' selected' : '' ?>><?= $item->name ?></option>
                    <?php endforeach; ?>
                </select>
                <div class="help-block"></div>
            </div>
        </div>

        <!-- блок выбора расположения -->
        <div class="box">
            <h6>Отдел </h6>
            <div class="form-group">
                <select class="form-control" name="Form[departmentId]">
                    <option value="">Все</option>
                    <?php foreach ($departments as $item): ?>
                        <option value="<?= $item->id ?>"<?= $filters['departmentId'] == $item->id ? ' selected' : '' ?>><?= $item->name ?></option>
                    <?php endforeach; ?>
                </select>
                <div class="help-block"></div>
            </div>
        </div>
        <input type="hidden" value=""/>
    </div>
    <?php ActiveForm::end() ?>
</div>

backend/views/widgets/views/_survey-filter.php
<?php

use yii\bootstrap4\ActiveForm;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\helpers\Json;
use common\models\SurveyType;
?>

<div class="pink-block">
    <div class="top-nav">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
        <div class="navbar-user">
            <div class="user">
                <div class="user-wrapper show-user-dropdown">
                    <div class="user-name"><?= Yii::$app->user->getIdentity()->surname_name ?></div>
                    <div class="icon-user"></div>
                </div>
                <div class="dropdown-user">
                    <ul>
                        <li>
                            <?= Html::a('Выход', ['site/logout'], [
                                'class' => 'logout',
                                'title' => 'Выход',
                                'data' => ['method' => 'post']]) ?>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-header"><?= $title ?></div>
    <?php $form = ActiveForm::begin([
        'id' => 'delivery-filter-form',
        'method' => 'post',
    ]); ?>
    <div class="filter-wrapper">
        <!-- блок выбора даты -->
        <div class="box box-date">
            <h6 class="f-name-height">Дата опроса</h6>
            <div class="form-group">
                <input type="text" class="form-control" name="Form[createdAt]"
                       value="<?= $filters['createdAt'] ?>">
                <div class="help-block"></div>
            </div>
        </div>

        <!-- блок выбора расположения -->
        <div class="box">
            <h6>Магазин</h6>
            <div class="form-group">
                <select class="form-control" name="Form[storeId]">
                    <option value="">Все</option>
                    <?php foreach ($stores as $item): ?>
                        <option value="<?= $item->id ?>"<?= $filters['storeId'] == $item->id ? ' selected' : '' ?>><?= $item->name ?></option>
                    <?php endforeach; ?>
                </select>
                <div class="help-block"></div>
            </div>
        </div>

        <!-- блок выбора расположения -->
        <div class="box">
            <h6>Отдел </h6>
            <div class="form-group">
                <select class="form-control" name="Form[departmentId]">
                    <option value="">Все</option>
                    <?php foreach ($departments as $item): ?>
                        <option value="<?= $item->id ?>"<?= $filters['departmentId'] == $item->id ? ' selected' : '' ?>><?= $item->name ?></option>
                    <?php endforeach; ?>
                </select>
                <div class="help-block"></div>
            </div>
        </div>

        <!-- блок выбора расположения -->
        <div class="box">
            <h6>Опросы</h6>
            <div class="form-group">
                <select class="form-control" name="Form[surveyTypeId]">
                    <option value="">Все</option>
                    <?php foreach (SurveyType::$valueNames as $key => $name): ?>
                        <option value="<?= $key ?>"<?= $filters['surveyTypeId'] == $key ? ' selected' : '' ?>><?= $name ?></option>
                    <?php endforeach; ?>
                </select>

                <div class="help-block"></div>
            </div>
        </div>
        <input type="hidden" value=""/>
    </div>

    <?php if ($showAlerts): ?>
        <div class="alerts-wrap">
            <div class="alert-item">
                <a href="<?= Url::current() ?>" class="alert-row" data-method="post"
                   data-params='<?= Json::encode(['mode' => 'all']) ?>'>
                    <div class="info-col">
                        <div class="name">
                            Всего анкет
                        </div>
                        <div class="sum">
                            <?= $filters['die']['total'] ?> из <?= $filters['die']['totalAll'] ?>
                        </div>
                    </div>
                    <div class="icon-col">
                        <div class="icon icon-all-anket"></div>
                    </div>
                </a>
            </div>
            <div class="alert-item">
                <a href="<?= Url::current() ?>" class="alert-row" data-method="post"
                   data-params='<?= Json::encode(['mode' => 'bad-nps']) ?>'>
                    <div class="info-col">
                        <div class="name">
                            Доля Алертов
                        </div>
                        <div class="sum">
                            <?= $filters['die']['badNps'] ?> %
                        </div>
                    </div>
                    <div class="icon-col">
                        <div class="icon icon-share-alert"></div>
                    </div>
                </a>
            </div>
            <div class="alert-item">
                <a href="<?= Url::current() ?>" class="alert-row" data-method="post"
                   data-params='<?= Json::encode(['mode' => 'expired']) ?>'>
                    <div class="info-col">
                        <div class="name">
                            Просроч. Алерты
                        </div>
                        <div class="sum">
                            <?= $filters['die']['expired'] ?>
                        </div>
                    </div>
                    <div class="icon-col">
                        <div class="icon icon-expired-alert"></div>
                    </div>
                </a>
            </div>
            <div class="alert-item">
                <a href="<?= Url::current() ?>" class="alert-row" data-method="post"
                   data-params='<?= Json::encode(['mode' => 'new']) ?>'>
                    <div class="info-col">
                        <div class="name">
                            Новые Алерты
                        </div>
                        <div class="sum">
                            <?= $filters['die']['new'] ?>
                        </div>
                    </div>
                    <div class="icon-col">
                        <div class="icon icon-new-alert"></div>
                    </div>
                </a>
            </div>
            <div class="alert-item">
                <a href="<?= Url::current() ?>" class="alert-row" data-method="post"
                   data-params='<?= Json::encode(['mode' => 'taken']) ?>'>
                    <div class="info-col">
                        <div class="name">
                            Алерты в работе
                        </div>
                        <div class="sum">
                            <?= $filters['die']['taken'] ?>
                        </div>
                    </div>
                    <div class="icon-col">
                        <div class="icon icon-alert-in-work"></div>
                    </div>
                </a>
            </div>
        </div>
    <?php endif; ?>
    <?php ActiveForm::end() ?>
</div>

backend/views/widgets/views/_user-filter.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;

?>

<div class="pink-block <?= $model ? ' profile-header' : '' ?>">
    <div class="top-nav">
        <div class="navbar-aside">
            <div class="mobile-menu btn-aside-menu toggle-sidebar">
                <div class="b-menu">
                    <div class="b-bun b-bun--top"></div>
                    <div class="b-bun b-bun--mid"></div>
                    <div class="b-bun b-bun--bottom"></div>
                </div>
            </div>
        </div>
        <div class="navbar-user">
            <div class="user">
                <div class="user-wrapper show-user-dropdown">
                    <div class="user-name"><?= Yii::$app->user->getIdentity()->surname_name ?></div>
                    <div class="icon-user"></div>
                </div>
                <div class="dropdown-user">
                    <ul>
                        <li>
                            <?= Html::a('Выход', ['site/logout'], [
                                'class' => 'logout',
                                'title' => 'Выход',
                                'data' => ['method' => 'post']]) ?>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-header"><?= $title ?></div>
    <div class="btn-back-wrap">
        <a href="<?= Url::to(['index']) ?>" class="btn-back btn-default">Назад</a>
    </div>
    <?php if ($model): ?>
        <div class="profile-wrapepr">
            <div class="profile-photo-box">
                <span class="photo-title">Профиль клиента</span>
                <div class="photo-container">
                    <?= Html::img('@web/img/user.svg', ['alt' => 'user', 'class' => 'user-img', 'id' => 'profileImage']) ?>
                    <div class="edit">
                        <i class="edit-con"></i>
                    </div>
                    <input id="imageUpload" type="file" name="profile_photo" capture>
                </div>
            </div>
            <div class="profile-info-box">
                <div class="info-row">
                    <div class="info-item">
                        <p class="info-name">Номер Алерта</p>
                        <p class="info-number"><?= $model->survey_id ?></p>
                    </div>
                    <div class="info-item">
                        <p class="info-name">Дата опроса</p>
                        <p class="info-number"><?= date('d.m.Y m:H', $model->created_at) ?></p>
                    </div>
                    <div class="info-item">
                        <p class="info-name">Имя</p>
                        <p class="info-number"><?= $model->client ? $model->client->name : '' ?></p>
                    </div>
                    <div class="info-item">
                        <p class="info-name">Телефон</p>
                        <p class="info-number"><?= $model->client ? $model->client->phone : '' ?></p>
                    </div>
                </div>
                <div class="info-row">
                    <div class="info-item">
                        <p class="info-name">Магазин</p>
                        <p class="info-number"><?= $model->store->name ?></p>
                    </div>
                    <div class="info-item">
                        <p class="info-name">Отдел</p>
                        <p class="info-number"><?= $model->department->name ?></p>
                    </div>
                    <div class="info-item">
                        <p class="info-name">E-mail</p>
                        <p class="info-number"><?= $model->client ? $model->client->email : '' ?></p>
                    </div>
                </div>
            </div>
        </div>
    <?php endif; ?>
</div>